// Data Refuge
// https://epa.gov/national-air-toxics-assessment/2011-nata-assessment-results
// D38E4558-F7D1-439F-A068-7EBBDD907265
//
// Author: Josh Dirk <symplekaos@gmail.com>

var casper = require('casper').create();
var parentURL = "https://epa.gov/national-air-toxics-assessment/2011-nata-assessment-results";

function getPollutants () {
  var pollutants = document.querySelectorAll('#jump-link > option');
  return Array.prototype.map.call(pollutants,function (e) {
    return e.value;
  });
}

function getStates () {
  var states = document.querySelectorAll('#jump-link3 > option');
  return Array.prototype.map.call(states,function (e) {
    return e.value;
  });
}

casper.start(parentURL);

casper.waitFor(function check () {
   return this.evaluate(function () {
    return document.querySelectorAll('#jump-link > option');
  });
}, function then() {
  var pollutants = this.evaluate(getPollutants);
  var states = this.evaluate(getStates);

  var parts,dataPath,fullURL;
  for (var i = 0; i < pollutants.length; i++) {
    var pollutant = pollutants[i];
    parts = pollutant.split('/');
    dataPath = 'data/pollutants/' + parts[parts.length -1];
    fullURL = parentURL + pollutant;
    this.echo(fullURL);
    this.download(fullURL,dataPath);
  }

  for (var j = 0; j < states.length; j++) {
    var state = states[j];
    parts = state.split('/');
    dataPath = 'data/states/' + parts[parts.length -1];
    fullURL = parentURL + state;
    this.echo(fullURL);
    this.download(fullURL,dataPath);
  }

});

casper.run();

